/* This file was generated by SableCC (http://www.sablecc.org/). */

package de.prob.unicode.lexer;

import java.io.*;
import java.util.*;
import de.prob.unicode.node.*;
import de.hhu.stups.sablecc.patch.*;
import java.util.concurrent.LinkedBlockingQueue;

@SuppressWarnings({"unused"}) 
public class Lexer implements ITokenListContainer
{
    protected Token token;
    protected State state = State.INITIAL;

    private PushbackReader in;
    private int line;
    private int pos;
    private boolean cr;
    private boolean eof;
    private final StringBuffer text = new StringBuffer();
    
	private List<IToken> tokenList;
    private final Queue<IToken> nextList = new LinkedBlockingQueue<IToken>();

	private IToken tok;

    public Queue<IToken> getNextList() {
        return nextList;
    }

	public List<IToken> getTokenList() {
		return tokenList;
	}
	
	private void setToken(Token t) {
	  tok = t;
   	  token = t;	
	}
	
	
	public void setTokenList(final List<IToken> list) {
		tokenList = list;
	}

     
    protected void filter() throws LexerException, IOException
    {
        // Do nothing
    }

    protected void filterWrap() throws LexerException, IOException
    {
       filter();
       if (token != null) {
	          getTokenList().add(token); 
              nextList.add(token);
	   }
    }


    public Lexer(  PushbackReader in)
    {
        this.in = in;
    	setTokenList(new ArrayList<IToken>());
    }
    
    public Token peek() throws LexerException, IOException
    {
        while(this.token == null)
        {
            this.setToken(getToken());
            filterWrap();
        }

        return (Token) nextList.peek();
    }

    public Token next() throws LexerException, IOException
    {
        while(this.token == null)
        {
            this.setToken(getToken());
            filterWrap();
        }

        Token result = (Token) nextList.poll();
        this.setToken(null);
        return result;
    }

    protected Token getToken() throws IOException, LexerException
    {
        int dfa_state = 0;

        int start_pos = this.pos;
        int start_line = this.line;

        int accept_state = -1;
        int accept_token = -1;
        int accept_length = -1;
        int accept_pos = -1;
        int accept_line = -1;

          int[][][] gotoTable = Lexer.gotoTable[this.state.id()];
          int[] accept = Lexer.accept[this.state.id()];
        this.text.setLength(0);

        while(true)
        {
            int c = getChar();

            if(c != -1)
            {
                switch(c)
                {
                case 10:
                    if(this.cr)
                    {
                        this.cr = false;
                    }
                    else
                    {
                        this.line++;
                        this.pos = 0;
                    }
                    break;
                case 13:
                    this.line++;
                    this.pos = 0;
                    this.cr = true;
                    break;
                default:
                    this.pos++;
                    this.cr = false;
                    break;
                }

                this.text.append((char) c);

                do
                {
                    int oldState = (dfa_state < -1) ? (-2 -dfa_state) : dfa_state;

                    dfa_state = -1;

                    int[][] tmp1 =  gotoTable[oldState];
                    int low = 0;
                    int high = tmp1.length - 1;

                    while(low <= high)
                    {
                        int middle = (low + high) / 2;
                        int[] tmp2 = tmp1[middle];

                        if(c < tmp2[0])
                        {
                            high = middle - 1;
                        }
                        else if(c > tmp2[1])
                        {
                            low = middle + 1;
                        }
                        else
                        {
                            dfa_state = tmp2[2];
                            break;
                        }
                    }
                }while(dfa_state < -1);
            }
            else
            {
                dfa_state = -1;
            }

            if(dfa_state >= 0)
            {
                if(accept[dfa_state] != -1)
                {
                    accept_state = dfa_state;
                    accept_token = accept[dfa_state];
                    accept_length = this.text.length();
                    accept_pos = this.pos;
                    accept_line = this.line;
                }
            }
            else
            {
                if(accept_state != -1)
                {
                    switch(accept_token)
                    {
                    case 0:
                        {
                              Token token = new0(
                                start_line + 1,
                                start_pos + 1);
                            pushBack(accept_length);
                            this.pos = accept_pos;
                            this.line = accept_line;
                            return token;
                        }
                    case 1:
                        {
                              Token token = new1(
                                start_line + 1,
                                start_pos + 1);
                            pushBack(accept_length);
                            this.pos = accept_pos;
                            this.line = accept_line;
                            return token;
                        }
                    case 2:
                        {
                              Token token = new2(
                                getText(accept_length),
                                start_line + 1,
                                start_pos + 1);
                            pushBack(accept_length);
                            this.pos = accept_pos;
                            this.line = accept_line;
                            return token;
                        }
                    case 3:
                        {
                              Token token = new3(
                                getText(accept_length),
                                start_line + 1,
                                start_pos + 1);
                            pushBack(accept_length);
                            this.pos = accept_pos;
                            this.line = accept_line;
                            return token;
                        }
                    case 4:
                        {
                              Token token = new4(
                                getText(accept_length),
                                start_line + 1,
                                start_pos + 1);
                            pushBack(accept_length);
                            this.pos = accept_pos;
                            this.line = accept_line;
                            return token;
                        }
                    case 5:
                        {
                              Token token = new5(
                                getText(accept_length),
                                start_line + 1,
                                start_pos + 1);
                            pushBack(accept_length);
                            this.pos = accept_pos;
                            this.line = accept_line;
                            return token;
                        }
                    case 6:
                        {
                              Token token = new6(
                                getText(accept_length),
                                start_line + 1,
                                start_pos + 1);
                            pushBack(accept_length);
                            this.pos = accept_pos;
                            this.line = accept_line;
                            return token;
                        }
                    case 7:
                        {
                              Token token = new7(
                                getText(accept_length),
                                start_line + 1,
                                start_pos + 1);
                            pushBack(accept_length);
                            this.pos = accept_pos;
                            this.line = accept_line;
                            return token;
                        }
                    case 8:
                        {
                              Token token = new8(
                                getText(accept_length),
                                start_line + 1,
                                start_pos + 1);
                            pushBack(accept_length);
                            this.pos = accept_pos;
                            this.line = accept_line;
                            return token;
                        }
                    case 9:
                        {
                              Token token = new9(
                                getText(accept_length),
                                start_line + 1,
                                start_pos + 1);
                            pushBack(accept_length);
                            this.pos = accept_pos;
                            this.line = accept_line;
                            return token;
                        }
                    case 10:
                        {
                              Token token = new10(
                                getText(accept_length),
                                start_line + 1,
                                start_pos + 1);
                            pushBack(accept_length);
                            this.pos = accept_pos;
                            this.line = accept_line;
                            return token;
                        }
                    case 11:
                        {
                              Token token = new11(
                                getText(accept_length),
                                start_line + 1,
                                start_pos + 1);
                            pushBack(accept_length);
                            this.pos = accept_pos;
                            this.line = accept_line;
                            return token;
                        }
                    case 12:
                        {
                              Token token = new12(
                                getText(accept_length),
                                start_line + 1,
                                start_pos + 1);
                            pushBack(accept_length);
                            this.pos = accept_pos;
                            this.line = accept_line;
                            return token;
                        }
                    case 13:
                        {
                              Token token = new13(
                                getText(accept_length),
                                start_line + 1,
                                start_pos + 1);
                            pushBack(accept_length);
                            this.pos = accept_pos;
                            this.line = accept_line;
                            return token;
                        }
                    case 14:
                        {
                              Token token = new14(
                                getText(accept_length),
                                start_line + 1,
                                start_pos + 1);
                            pushBack(accept_length);
                            this.pos = accept_pos;
                            this.line = accept_line;
                            return token;
                        }
                    case 15:
                        {
                              Token token = new15(
                                getText(accept_length),
                                start_line + 1,
                                start_pos + 1);
                            pushBack(accept_length);
                            this.pos = accept_pos;
                            this.line = accept_line;
                            return token;
                        }
                    case 16:
                        {
                              Token token = new16(
                                getText(accept_length),
                                start_line + 1,
                                start_pos + 1);
                            pushBack(accept_length);
                            this.pos = accept_pos;
                            this.line = accept_line;
                            return token;
                        }
                    case 17:
                        {
                              Token token = new17(
                                getText(accept_length),
                                start_line + 1,
                                start_pos + 1);
                            pushBack(accept_length);
                            this.pos = accept_pos;
                            this.line = accept_line;
                            return token;
                        }
                    case 18:
                        {
                              Token token = new18(
                                getText(accept_length),
                                start_line + 1,
                                start_pos + 1);
                            pushBack(accept_length);
                            this.pos = accept_pos;
                            this.line = accept_line;
                            return token;
                        }
                    case 19:
                        {
                              Token token = new19(
                                getText(accept_length),
                                start_line + 1,
                                start_pos + 1);
                            pushBack(accept_length);
                            this.pos = accept_pos;
                            this.line = accept_line;
                            return token;
                        }
                    case 20:
                        {
                              Token token = new20(
                                getText(accept_length),
                                start_line + 1,
                                start_pos + 1);
                            pushBack(accept_length);
                            this.pos = accept_pos;
                            this.line = accept_line;
                            return token;
                        }
                    case 21:
                        {
                              Token token = new21(
                                getText(accept_length),
                                start_line + 1,
                                start_pos + 1);
                            pushBack(accept_length);
                            this.pos = accept_pos;
                            this.line = accept_line;
                            return token;
                        }
                    case 22:
                        {
                              Token token = new22(
                                getText(accept_length),
                                start_line + 1,
                                start_pos + 1);
                            pushBack(accept_length);
                            this.pos = accept_pos;
                            this.line = accept_line;
                            return token;
                        }
                    case 23:
                        {
                              Token token = new23(
                                getText(accept_length),
                                start_line + 1,
                                start_pos + 1);
                            pushBack(accept_length);
                            this.pos = accept_pos;
                            this.line = accept_line;
                            return token;
                        }
                    case 24:
                        {
                              Token token = new24(
                                getText(accept_length),
                                start_line + 1,
                                start_pos + 1);
                            pushBack(accept_length);
                            this.pos = accept_pos;
                            this.line = accept_line;
                            return token;
                        }
                    case 25:
                        {
                              Token token = new25(
                                getText(accept_length),
                                start_line + 1,
                                start_pos + 1);
                            pushBack(accept_length);
                            this.pos = accept_pos;
                            this.line = accept_line;
                            return token;
                        }
                    case 26:
                        {
                              Token token = new26(
                                getText(accept_length),
                                start_line + 1,
                                start_pos + 1);
                            pushBack(accept_length);
                            this.pos = accept_pos;
                            this.line = accept_line;
                            return token;
                        }
                    case 27:
                        {
                              Token token = new27(
                                getText(accept_length),
                                start_line + 1,
                                start_pos + 1);
                            pushBack(accept_length);
                            this.pos = accept_pos;
                            this.line = accept_line;
                            return token;
                        }
                    case 28:
                        {
                              Token token = new28(
                                getText(accept_length),
                                start_line + 1,
                                start_pos + 1);
                            pushBack(accept_length);
                            this.pos = accept_pos;
                            this.line = accept_line;
                            return token;
                        }
                    case 29:
                        {
                              Token token = new29(
                                getText(accept_length),
                                start_line + 1,
                                start_pos + 1);
                            pushBack(accept_length);
                            this.pos = accept_pos;
                            this.line = accept_line;
                            return token;
                        }
                    case 30:
                        {
                              Token token = new30(
                                getText(accept_length),
                                start_line + 1,
                                start_pos + 1);
                            pushBack(accept_length);
                            this.pos = accept_pos;
                            this.line = accept_line;
                            return token;
                        }
                    case 31:
                        {
                              Token token = new31(
                                getText(accept_length),
                                start_line + 1,
                                start_pos + 1);
                            pushBack(accept_length);
                            this.pos = accept_pos;
                            this.line = accept_line;
                            return token;
                        }
                    case 32:
                        {
                              Token token = new32(
                                getText(accept_length),
                                start_line + 1,
                                start_pos + 1);
                            pushBack(accept_length);
                            this.pos = accept_pos;
                            this.line = accept_line;
                            return token;
                        }
                    case 33:
                        {
                              Token token = new33(
                                getText(accept_length),
                                start_line + 1,
                                start_pos + 1);
                            pushBack(accept_length);
                            this.pos = accept_pos;
                            this.line = accept_line;
                            return token;
                        }
                    case 34:
                        {
                              Token token = new34(
                                getText(accept_length),
                                start_line + 1,
                                start_pos + 1);
                            pushBack(accept_length);
                            this.pos = accept_pos;
                            this.line = accept_line;
                            return token;
                        }
                    case 35:
                        {
                              Token token = new35(
                                getText(accept_length),
                                start_line + 1,
                                start_pos + 1);
                            pushBack(accept_length);
                            this.pos = accept_pos;
                            this.line = accept_line;
                            return token;
                        }
                    case 36:
                        {
                              Token token = new36(
                                getText(accept_length),
                                start_line + 1,
                                start_pos + 1);
                            pushBack(accept_length);
                            this.pos = accept_pos;
                            this.line = accept_line;
                            return token;
                        }
                    case 37:
                        {
                              Token token = new37(
                                getText(accept_length),
                                start_line + 1,
                                start_pos + 1);
                            pushBack(accept_length);
                            this.pos = accept_pos;
                            this.line = accept_line;
                            return token;
                        }
                    case 38:
                        {
                              Token token = new38(
                                getText(accept_length),
                                start_line + 1,
                                start_pos + 1);
                            pushBack(accept_length);
                            this.pos = accept_pos;
                            this.line = accept_line;
                            return token;
                        }
                    case 39:
                        {
                              Token token = new39(
                                getText(accept_length),
                                start_line + 1,
                                start_pos + 1);
                            pushBack(accept_length);
                            this.pos = accept_pos;
                            this.line = accept_line;
                            return token;
                        }
                    case 40:
                        {
                              Token token = new40(
                                getText(accept_length),
                                start_line + 1,
                                start_pos + 1);
                            pushBack(accept_length);
                            this.pos = accept_pos;
                            this.line = accept_line;
                            return token;
                        }
                    case 41:
                        {
                              Token token = new41(
                                getText(accept_length),
                                start_line + 1,
                                start_pos + 1);
                            pushBack(accept_length);
                            this.pos = accept_pos;
                            this.line = accept_line;
                            return token;
                        }
                    case 42:
                        {
                              Token token = new42(
                                getText(accept_length),
                                start_line + 1,
                                start_pos + 1);
                            pushBack(accept_length);
                            this.pos = accept_pos;
                            this.line = accept_line;
                            return token;
                        }
                    case 43:
                        {
                              Token token = new43(
                                getText(accept_length),
                                start_line + 1,
                                start_pos + 1);
                            pushBack(accept_length);
                            this.pos = accept_pos;
                            this.line = accept_line;
                            return token;
                        }
                    case 44:
                        {
                              Token token = new44(
                                getText(accept_length),
                                start_line + 1,
                                start_pos + 1);
                            pushBack(accept_length);
                            this.pos = accept_pos;
                            this.line = accept_line;
                            return token;
                        }
                    case 45:
                        {
                              Token token = new45(
                                getText(accept_length),
                                start_line + 1,
                                start_pos + 1);
                            pushBack(accept_length);
                            this.pos = accept_pos;
                            this.line = accept_line;
                            return token;
                        }
                    case 46:
                        {
                              Token token = new46(
                                getText(accept_length),
                                start_line + 1,
                                start_pos + 1);
                            pushBack(accept_length);
                            this.pos = accept_pos;
                            this.line = accept_line;
                            return token;
                        }
                    case 47:
                        {
                              Token token = new47(
                                getText(accept_length),
                                start_line + 1,
                                start_pos + 1);
                            pushBack(accept_length);
                            this.pos = accept_pos;
                            this.line = accept_line;
                            return token;
                        }
                    case 48:
                        {
                              Token token = new48(
                                getText(accept_length),
                                start_line + 1,
                                start_pos + 1);
                            pushBack(accept_length);
                            this.pos = accept_pos;
                            this.line = accept_line;
                            return token;
                        }
                    case 49:
                        {
                              Token token = new49(
                                getText(accept_length),
                                start_line + 1,
                                start_pos + 1);
                            pushBack(accept_length);
                            this.pos = accept_pos;
                            this.line = accept_line;
                            return token;
                        }
                    case 50:
                        {
                              Token token = new50(
                                getText(accept_length),
                                start_line + 1,
                                start_pos + 1);
                            pushBack(accept_length);
                            this.pos = accept_pos;
                            this.line = accept_line;
                            return token;
                        }
                    case 51:
                        {
                              Token token = new51(
                                getText(accept_length),
                                start_line + 1,
                                start_pos + 1);
                            pushBack(accept_length);
                            this.pos = accept_pos;
                            this.line = accept_line;
                            return token;
                        }
                    case 52:
                        {
                              Token token = new52(
                                getText(accept_length),
                                start_line + 1,
                                start_pos + 1);
                            pushBack(accept_length);
                            this.pos = accept_pos;
                            this.line = accept_line;
                            return token;
                        }
                    case 53:
                        {
                              Token token = new53(
                                getText(accept_length),
                                start_line + 1,
                                start_pos + 1);
                            pushBack(accept_length);
                            this.pos = accept_pos;
                            this.line = accept_line;
                            return token;
                        }
                    case 54:
                        {
                              Token token = new54(
                                getText(accept_length),
                                start_line + 1,
                                start_pos + 1);
                            pushBack(accept_length);
                            this.pos = accept_pos;
                            this.line = accept_line;
                            return token;
                        }
                    case 55:
                        {
                              Token token = new55(
                                getText(accept_length),
                                start_line + 1,
                                start_pos + 1);
                            pushBack(accept_length);
                            this.pos = accept_pos;
                            this.line = accept_line;
                            return token;
                        }
                    case 56:
                        {
                              Token token = new56(
                                getText(accept_length),
                                start_line + 1,
                                start_pos + 1);
                            pushBack(accept_length);
                            this.pos = accept_pos;
                            this.line = accept_line;
                            return token;
                        }
                    case 57:
                        {
                              Token token = new57(
                                getText(accept_length),
                                start_line + 1,
                                start_pos + 1);
                            pushBack(accept_length);
                            this.pos = accept_pos;
                            this.line = accept_line;
                            return token;
                        }
                    case 58:
                        {
                              Token token = new58(
                                getText(accept_length),
                                start_line + 1,
                                start_pos + 1);
                            pushBack(accept_length);
                            this.pos = accept_pos;
                            this.line = accept_line;
                            return token;
                        }
                    case 59:
                        {
                              Token token = new59(
                                getText(accept_length),
                                start_line + 1,
                                start_pos + 1);
                            pushBack(accept_length);
                            this.pos = accept_pos;
                            this.line = accept_line;
                            return token;
                        }
                    case 60:
                        {
                              Token token = new60(
                                getText(accept_length),
                                start_line + 1,
                                start_pos + 1);
                            pushBack(accept_length);
                            this.pos = accept_pos;
                            this.line = accept_line;
                            return token;
                        }
                    case 61:
                        {
                              Token token = new61(
                                getText(accept_length),
                                start_line + 1,
                                start_pos + 1);
                            pushBack(accept_length);
                            this.pos = accept_pos;
                            this.line = accept_line;
                            return token;
                        }
                    case 62:
                        {
                              Token token = new62(
                                getText(accept_length),
                                start_line + 1,
                                start_pos + 1);
                            pushBack(accept_length);
                            this.pos = accept_pos;
                            this.line = accept_line;
                            return token;
                        }
                    case 63:
                        {
                              Token token = new63(
                                getText(accept_length),
                                start_line + 1,
                                start_pos + 1);
                            pushBack(accept_length);
                            this.pos = accept_pos;
                            this.line = accept_line;
                            return token;
                        }
                    case 64:
                        {
                              Token token = new64(
                                getText(accept_length),
                                start_line + 1,
                                start_pos + 1);
                            pushBack(accept_length);
                            this.pos = accept_pos;
                            this.line = accept_line;
                            return token;
                        }
                    case 65:
                        {
                              Token token = new65(
                                getText(accept_length),
                                start_line + 1,
                                start_pos + 1);
                            pushBack(accept_length);
                            this.pos = accept_pos;
                            this.line = accept_line;
                            return token;
                        }
                    case 66:
                        {
                              Token token = new66(
                                start_line + 1,
                                start_pos + 1);
                            pushBack(accept_length);
                            this.pos = accept_pos;
                            this.line = accept_line;
                            return token;
                        }
                    case 67:
                        {
                              Token token = new67(
                                start_line + 1,
                                start_pos + 1);
                            pushBack(accept_length);
                            this.pos = accept_pos;
                            this.line = accept_line;
                            return token;
                        }
                    case 68:
                        {
                              Token token = new68(
                                getText(accept_length),
                                start_line + 1,
                                start_pos + 1);
                            pushBack(accept_length);
                            this.pos = accept_pos;
                            this.line = accept_line;
                            return token;
                        }
                    case 69:
                        {
                              Token token = new69(
                                getText(accept_length),
                                start_line + 1,
                                start_pos + 1);
                            pushBack(accept_length);
                            this.pos = accept_pos;
                            this.line = accept_line;
                            return token;
                        }
                    case 70:
                        {
                              Token token = new70(
                                getText(accept_length),
                                start_line + 1,
                                start_pos + 1);
                            pushBack(accept_length);
                            this.pos = accept_pos;
                            this.line = accept_line;
                            return token;
                        }
                    }
                }
                else
                {
                    if(this.text.length() > 0)
                    {
                        throw new LexerException(
                            "[" + (start_line + 1) + "," + (start_pos + 1) + "]" +
                            " Unknown token: " + this.text);
                    }

                      EOF token = new EOF(
                        start_line + 1,
                        start_pos + 1);
                    return token;
                }
            }
        }
    }

    Token new0(  int line,   int pos) { return new TTypeofOpen(line, pos); }
    Token new1(  int line,   int pos) { return new TTypeofClose(line, pos); }
    Token new2(  String text,   int line,   int pos) { return new TIn(text, line, pos); }
    Token new3(  String text,   int line,   int pos) { return new TNotsubseteq(text, line, pos); }
    Token new4(  String text,   int line,   int pos) { return new TNotsubset(text, line, pos); }
    Token new5(  String text,   int line,   int pos) { return new TSubseteq(text, line, pos); }
    Token new6(  String text,   int line,   int pos) { return new TSetminus(text, line, pos); }
    Token new7(  String text,   int line,   int pos) { return new TDotdot(text, line, pos); }
    Token new8(  String text,   int line,   int pos) { return new TNat1(text, line, pos); }
    Token new9(  String text,   int line,   int pos) { return new TNat(text, line, pos); }
    Token new10(  String text,   int line,   int pos) { return new TEmptyset(text, line, pos); }
    Token new11(  String text,   int line,   int pos) { return new TBcmsuch(text, line, pos); }
    Token new12(  String text,   int line,   int pos) { return new TBfalse(text, line, pos); }
    Token new13(  String text,   int line,   int pos) { return new TForall(text, line, pos); }
    Token new14(  String text,   int line,   int pos) { return new TExists(text, line, pos); }
    Token new15(  String text,   int line,   int pos) { return new TMapsto(text, line, pos); }
    Token new16(  String text,   int line,   int pos) { return new TBtrue(text, line, pos); }
    Token new17(  String text,   int line,   int pos) { return new TSubset(text, line, pos); }
    Token new18(  String text,   int line,   int pos) { return new TBunion(text, line, pos); }
    Token new19(  String text,   int line,   int pos) { return new TBinter(text, line, pos); }
    Token new20(  String text,   int line,   int pos) { return new TDomres(text, line, pos); }
    Token new21(  String text,   int line,   int pos) { return new TRanres(text, line, pos); }
    Token new22(  String text,   int line,   int pos) { return new TDomsub(text, line, pos); }
    Token new23(  String text,   int line,   int pos) { return new TRansub(text, line, pos); }
    Token new24(  String text,   int line,   int pos) { return new TLambda(text, line, pos); }
    Token new25(  String text,   int line,   int pos) { return new TOftype(text, line, pos); }
    Token new26(  String text,   int line,   int pos) { return new TNotin(text, line, pos); }
    Token new27(  String text,   int line,   int pos) { return new TCprod(text, line, pos); }
    Token new28(  String text,   int line,   int pos) { return new TUnion(text, line, pos); }
    Token new29(  String text,   int line,   int pos) { return new TInter(text, line, pos); }
    Token new30(  String text,   int line,   int pos) { return new TFcomp(text, line, pos); }
    Token new31(  String text,   int line,   int pos) { return new TBcomp(text, line, pos); }
    Token new32(  String text,   int line,   int pos) { return new TStrel(text, line, pos); }
    Token new33(  String text,   int line,   int pos) { return new TDprod(text, line, pos); }
    Token new34(  String text,   int line,   int pos) { return new TPprod(text, line, pos); }
    Token new35(  String text,   int line,   int pos) { return new TBcmeq(text, line, pos); }
    Token new36(  String text,   int line,   int pos) { return new TBcmin(text, line, pos); }
    Token new37(  String text,   int line,   int pos) { return new TIntg(text, line, pos); }
    Token new38(  String text,   int line,   int pos) { return new TLand(text, line, pos); }
    Token new39(  String text,   int line,   int pos) { return new TLimp(text, line, pos); }
    Token new40(  String text,   int line,   int pos) { return new TLeqv(text, line, pos); }
    Token new41(  String text,   int line,   int pos) { return new TLnot(text, line, pos); }
    Token new42(  String text,   int line,   int pos) { return new TQdot(text, line, pos); }
    Token new43(  String text,   int line,   int pos) { return new TConv(text, line, pos); }
    Token new44(  String text,   int line,   int pos) { return new TTrel(text, line, pos); }
    Token new45(  String text,   int line,   int pos) { return new TSrel(text, line, pos); }
    Token new46(  String text,   int line,   int pos) { return new TPfun(text, line, pos); }
    Token new47(  String text,   int line,   int pos) { return new TTfun(text, line, pos); }
    Token new48(  String text,   int line,   int pos) { return new TPinj(text, line, pos); }
    Token new49(  String text,   int line,   int pos) { return new TTinj(text, line, pos); }
    Token new50(  String text,   int line,   int pos) { return new TPsur(text, line, pos); }
    Token new51(  String text,   int line,   int pos) { return new TTsur(text, line, pos); }
    Token new52(  String text,   int line,   int pos) { return new TTbij(text, line, pos); }
    Token new53(  String text,   int line,   int pos) { return new TExpn(text, line, pos); }
    Token new54(  String text,   int line,   int pos) { return new TLor(text, line, pos); }
    Token new55(  String text,   int line,   int pos) { return new TPow1(text, line, pos); }
    Token new56(  String text,   int line,   int pos) { return new TPow(text, line, pos); }
    Token new57(  String text,   int line,   int pos) { return new TMid(text, line, pos); }
    Token new58(  String text,   int line,   int pos) { return new TNeq(text, line, pos); }
    Token new59(  String text,   int line,   int pos) { return new TRel(text, line, pos); }
    Token new60(  String text,   int line,   int pos) { return new TOvl(text, line, pos); }
    Token new61(  String text,   int line,   int pos) { return new TLeq(text, line, pos); }
    Token new62(  String text,   int line,   int pos) { return new TGeq(text, line, pos); }
    Token new63(  String text,   int line,   int pos) { return new TDiv(text, line, pos); }
    Token new64(  String text,   int line,   int pos) { return new TMult(text, line, pos); }
    Token new65(  String text,   int line,   int pos) { return new TMinus(text, line, pos); }
    Token new66(  int line,   int pos) { return new TTake(line, pos); }
    Token new67(  int line,   int pos) { return new TDrop(line, pos); }
    Token new68(  String text,   int line,   int pos) { return new TAnyChar(text, line, pos); }
    Token new69(  String text,   int line,   int pos) { return new TWhitespace(text, line, pos); }
    Token new70(  String text,   int line,   int pos) { return new TSeparator(text, line, pos); }

    private int getChar() throws IOException
    {
        if(this.eof)
        {
            return -1;
        }

        int result = this.in.read();

        if(result == -1)
        {
            this.eof = true;
        }

        return result;
    }

    private void pushBack(int acceptLength) throws IOException
    {
        int length = this.text.length();
        for(int i = length - 1; i >= acceptLength; i--)
        {
            this.eof = false;

            this.in.unread(this.text.charAt(i));
        }
    }

    protected void unread(  Token token) throws IOException
    {
          String text = token.getText();
        int length = text.length();

        for(int i = length - 1; i >= 0; i--)
        {
            this.eof = false;

            this.in.unread(text.charAt(i));
        }

        this.pos = token.getPos() - 1;
        this.line = token.getLine() - 1;
    }

    private String getText(int acceptLength)
    {
        StringBuffer s = new StringBuffer(acceptLength);
        for(int i = 0; i < acceptLength; i++)
        {
            s.append(this.text.charAt(i));
        }

        return s.toString();
    }

    private static int[][][][] gotoTable;
/*  {
        { // INITIAL
            {{0, 8, 1}, {9, 10, 2}, {11, 12, 1}, {13, 13, 2}, {14, 31, 1}, {32, 32, 2}, {33, 33, 3}, {34, 34, 1}, {35, 35, 4}, {36, 36, 1}, {37, 37, 5}, {38, 38, 6}, {39, 39, 1}, {40, 41, 7}, {42, 42, 8}, {43, 43, 9}, {44, 44, 7}, {45, 45, 10}, {46, 46, 11}, {47, 47, 12}, {48, 57, 1}, {58, 58, 13}, {59, 59, 14}, {60, 60, 15}, {61, 61, 16}, {62, 62, 17}, {63, 72, 1}, {73, 73, 18}, {74, 77, 1}, {78, 78, 19}, {79, 79, 1}, {80, 80, 20}, {81, 84, 1}, {85, 85, 21}, {86, 91, 1}, {92, 92, 22}, {93, 93, 1}, {94, 94, 23}, {95, 98, 1}, {99, 99, 24}, {100, 101, 1}, {102, 102, 25}, {103, 109, 1}, {110, 110, 26}, {111, 111, 27}, {112, 115, 1}, {116, 116, 28}, {117, 122, 1}, {123, 123, 29}, {124, 124, 30}, {125, 125, 7}, {126, 126, 31}, {127, 171, 1}, {172, 172, 32}, {173, 182, 1}, {183, 183, 33}, {184, 214, 1}, {215, 215, 34}, {216, 246, 1}, {247, 247, 35}, {248, 954, 1}, {955, 955, 36}, {956, 8228, 1}, {8229, 8229, 37}, {8230, 8468, 1}, {8469, 8469, 38}, {8470, 8472, 1}, {8473, 8473, 39}, {8474, 8483, 1}, {8484, 8484, 40}, {8485, 8593, 1}, {8594, 8594, 41}, {8595, 8595, 1}, {8596, 8596, 42}, {8597, 8607, 1}, {8608, 8608, 43}, {8609, 8610, 1}, {8611, 8611, 44}, {8612, 8613, 1}, {8614, 8614, 45}, {8615, 8657, 1}, {8658, 8658, 46}, {8659, 8659, 1}, {8660, 8660, 47}, {8661, 8695, 1}, {8696, 8696, 48}, {8697, 8703, 1}, {8704, 8704, 49}, {8705, 8706, 1}, {8707, 8707, 50}, {8708, 8708, 1}, {8709, 8709, 51}, {8710, 8711, 1}, {8712, 8712, 52}, {8713, 8713, 53}, {8714, 8721, 1}, {8722, 8722, 54}, {8723, 8725, 1}, {8726, 8726, 55}, {8727, 8727, 56}, {8728, 8728, 57}, {8729, 8738, 1}, {8739, 8739, 58}, {8740, 8740, 1}, {8741, 8741, 59}, {8742, 8742, 1}, {8743, 8743, 60}, {8744, 8744, 61}, {8745, 8745, 62}, {8746, 8746, 63}, {8747, 8763, 1}, {8764, 8764, 64}, {8765, 8787, 1}, {8788, 8788, 65}, {8789, 8799, 1}, {8800, 8800, 66}, {8801, 8803, 1}, {8804, 8804, 67}, {8805, 8805, 68}, {8806, 8833, 1}, {8834, 8834, 69}, {8835, 8835, 1}, {8836, 8836, 70}, {8837, 8837, 1}, {8838, 8838, 71}, {8839, 8839, 1}, {8840, 8840, 72}, {8841, 8854, 1}, {8855, 8855, 73}, {8856, 8867, 1}, {8868, 8868, 74}, {8869, 8869, 75}, {8870, 8897, 1}, {8898, 8898, 76}, {8899, 8899, 77}, {8900, 9654, 1}, {9655, 9655, 78}, {9656, 9664, 1}, {9665, 9665, 79}, {9666, 10495, 1}, {10496, 10496, 80}, {10497, 10515, 1}, {10516, 10516, 81}, {10517, 10517, 1}, {10518, 10518, 82}, {10519, 10625, 1}, {10626, 10626, 83}, {10627, 10851, 1}, {10852, 10852, 84}, {10853, 10853, 85}, {10854, 57599, 1}, {57600, 57600, 86}, {57601, 57601, 87}, {57602, 57602, 88}, {57603, 57603, 89}, {57604, 65535, 1}, },
            {{0, 8, 1}, {11, 12, 1}, {14, 31, 1}, {34, 34, 1}, {36, 36, 1}, {39, 39, 1}, {48, 57, 1}, {63, 91, 1}, {93, 93, 1}, {95, 122, 1}, {127, 171, 1}, {173, 182, 1}, {184, 214, 1}, {216, 246, 1}, {248, 954, 1}, {956, 8228, 1}, {8230, 8468, 1}, {8470, 8472, 1}, {8474, 8483, 1}, {8485, 8593, 1}, {8595, 8595, 1}, {8597, 8607, 1}, {8609, 8610, 1}, {8612, 8613, 1}, {8615, 8657, 1}, {8659, 8659, 1}, {8661, 8695, 1}, {8697, 8703, 1}, {8705, 8706, 1}, {8708, 8708, 1}, {8710, 8711, 1}, {8714, 8721, 1}, {8723, 8725, 1}, {8729, 8738, 1}, {8740, 8740, 1}, {8742, 8742, 1}, {8747, 8763, 1}, {8765, 8787, 1}, {8789, 8799, 1}, {8801, 8803, 1}, {8806, 8833, 1}, {8835, 8835, 1}, {8837, 8837, 1}, {8839, 8839, 1}, {8841, 8854, 1}, {8856, 8867, 1}, {8870, 8897, 1}, {8900, 9654, 1}, {9656, 9664, 1}, {9666, 10495, 1}, {10497, 10515, 1}, {10517, 10517, 1}, {10519, 10625, 1}, {10627, 10851, 1}, {10854, 57599, 1}, {57604, 65535, 1}, },
            {{9, 10, 2}, {13, 13, 2}, {32, 32, 2}, },
            {},
            {},
            {},
            {},
            {},
            {{42, 42, 90}, {47, 47, 91}, },
            {{45, 45, 92}, {62, 62, 93}, },
            {{45, 45, 94}, {62, 62, 95}, },
            {{46, 46, 96}, },
            {{42, 42, 97}, {58, 58, 98}, {60, 60, 99}, {61, 61, 100}, {92, 92, 101}, {124, 124, 102}, },
            {{58, 58, 103}, {61, 61, 104}, {124, 124, 105}, {8712, 8712, 106}, {8739, 8739, 107}, },
            {},
            {{43, 43, 108}, {45, 45, 109}, {58, 58, 110}, {60, 60, 111}, {61, 61, 112}, {124, 124, 113}, },
            {{62, 62, 114}, },
            {{43, 43, 115}, {45, 45, 116}, {60, 60, 117}, {61, 61, 118}, },
            {{0, 57, -3}, {63, 77, 1}, {78, 78, 119}, {79, 91, 1}, {93, 65535, -3}, },
            {{0, 57, -3}, {63, 64, 1}, {65, 65, 120}, {66, 91, 1}, {93, 65535, -3}, },
            {{0, 57, -3}, {63, 78, 1}, {79, 79, 121}, {80, 91, 1}, {93, 65535, -3}, },
            {{0, 77, -20}, {78, 78, 122}, {79, 65535, -20}, },
            {{47, 47, 123}, {48, 48, 124}, {73, 73, 125}, {85, 85, 126}, {98, 98, 127}, {99, 99, 128}, {100, 100, 129}, {101, 101, 130}, {102, 102, 131}, {103, 103, 132}, {105, 105, 133}, {108, 108, 134}, {109, 109, 135}, {110, 110, 136}, {111, 111, 137}, {112, 112, 138}, {113, 113, 139}, {114, 114, 140}, {115, 115, 141}, {116, 116, 142}, {124, 124, 143}, },
            {},
            {{0, 93, -3}, {95, 104, 1}, {105, 105, 144}, {106, 122, 1}, {127, 65535, -3}, },
            {{0, 93, -3}, {95, 96, 1}, {97, 97, 145}, {98, 122, 1}, {127, 65535, -3}, },
            {{0, 93, -3}, {95, 110, 1}, {111, 111, 146}, {112, 122, 1}, {127, 65535, -3}, },
            {{0, 93, -3}, {95, 101, 1}, {102, 102, 147}, {103, 113, 1}, {114, 114, 148}, {115, 122, 1}, {127, 65535, -3}, },
            {{0, 93, -3}, {95, 113, 1}, {114, 114, 149}, {115, 65535, -29}, },
            {{125, 125, 150}, },
            {{45, 45, 151}, {62, 62, 152}, {124, 124, 153}, },
            {},
            {},
            {},
            {},
            {},
            {},
            {},
            {{49, 49, 154}, },
            {{49, 49, 155}, },
            {},
            {},
            {},
            {},
            {},
            {},
            {},
            {},
            {},
            {},
            {},
            {},
            {},
            {},
            {},
            {},
            {},
            {},
            {},
            {},
            {},
            {},
            {},
            {},
            {},
            {},
            {},
            {},
            {},
            {},
            {},
            {},
            {},
            {},
            {},
            {},
            {},
            {},
            {},
            {},
            {},
            {},
            {},
            {},
            {},
            {},
            {},
            {},
            {},
            {},
            {},
            {},
            {{62, 62, 156}, },
            {{62, 62, 157}, },
            {{62, 62, 158}, },
            {{62, 62, 159}, },
            {},
            {},
            {},
            {{58, 58, 160}, {60, 60, 161}, },
            {},
            {},
            {{92, 92, 162}, },
            {},
            {},
            {},
            {},
            {},
            {},
            {{62, 62, 163}, },
            {},
            {{45, 45, 164}, {58, 58, 165}, {124, 124, 166}, },
            {{62, 62, 167}, },
            {},
            {},
            {{62, 62, 168}, },
            {{62, 62, 169}, },
            {},
            {},
            {{0, 57, -3}, {63, 83, 1}, {84, 84, 170}, {85, 91, 1}, {93, 65535, -3}, },
            {{0, 83, -121}, {84, 84, 171}, {85, 65535, -121}, },
            {{0, 57, -3}, {63, 86, 1}, {87, 87, 172}, {88, 91, 1}, {93, 65535, -3}, },
            {{0, 57, -3}, {63, 72, 1}, {73, 73, 173}, {74, 91, 1}, {93, 65535, -3}, },
            {},
            {{120, 120, 174}, },
            {{110, 110, 175}, },
            {{110, 110, 176}, },
            {{99, 99, 177}, {102, 102, 178}, {105, 105, 179}, {116, 116, 180}, {117, 117, 181}, },
            {{111, 111, 182}, {112, 112, 183}, },
            {{105, 105, 184}, {111, 111, 185}, {112, 112, 186}, },
            {{109, 109, 187}, {120, 120, 188}, },
            {{99, 99, 189}, {111, 111, 190}, },
            {{101, 101, 191}, },
            {{110, 110, 192}, },
            {{97, 97, 193}, {101, 101, 194}, {105, 105, 195}, {110, 110, 196}, {111, 111, 197}, },
            {{97, 97, 198}, {105, 105, 199}, },
            {{97, 97, 200}, {101, 101, 201}, {111, 111, 202}, },
            {{102, 102, 203}, {118, 118, 204}, },
            {{102, 102, 205}, {105, 105, 206}, {111, 111, 207}, {112, 112, 208}, {115, 115, 209}, },
            {{100, 100, 210}, },
            {{97, 97, 211}, {101, 101, 212}, },
            {{101, 101, 213}, {114, 114, 214}, {116, 116, 215}, {117, 117, 216}, },
            {{98, 98, 217}, {102, 102, 218}, {105, 105, 219}, {114, 114, 220}, {115, 115, 221}, },
            {{47, 47, 222}, },
            {{0, 113, -30}, {114, 114, 223}, {115, 65535, -29}, },
            {{0, 93, -3}, {95, 107, 1}, {108, 108, 224}, {109, 122, 1}, {127, 65535, -3}, },
            {{0, 93, -3}, {95, 115, 1}, {116, 116, 225}, {117, 122, 1}, {127, 65535, -3}, },
            {{0, 115, -148}, {116, 116, 226}, {117, 65535, -148}, },
            {{0, 65535, -3}, },
            {{0, 93, -3}, {95, 116, 1}, {117, 117, 227}, {118, 122, 1}, {127, 65535, -3}, },
            {},
            {{62, 62, 228}, },
            {{62, 62, 229}, },
            {},
            {},
            {},
            {},
            {},
            {},
            {},
            {},
            {{58, 58, 230}, },
            {},
            {{62, 62, 231}, },
            {{62, 62, 232}, },
            {},
            {},
            {},
            {},
            {{62, 62, 233}, },
            {{0, 57, -3}, {63, 68, 1}, {69, 69, 234}, {70, 91, 1}, {93, 65535, -3}, },
            {{0, 39, -3}, {48, 48, 1}, {49, 49, 235}, {50, 57, 1}, {63, 65535, -3}, },
            {{0, 48, -173}, {49, 49, 236}, {50, 65535, -173}, },
            {{0, 78, -22}, {79, 79, 237}, {80, 65535, -22}, },
            {{112, 112, 238}, },
            {{116, 116, 239}, },
            {{105, 105, 240}, },
            {{109, 109, 241}, {111, 111, 242}, },
            {{97, 97, 243}, },
            {{110, 110, 244}, },
            {{114, 114, 245}, },
            {{110, 110, 246}, },
            {{110, 110, 247}, },
            {{114, 114, 248}, },
            {{118, 118, 249}, },
            {{109, 109, 250}, },
            {{114, 114, 251}, },
            {{112, 112, 252}, },
            {{105, 105, 253}, {112, 112, 254}, },
            {{111, 111, 255}, },
            {{114, 114, 256}, },
            {{113, 113, 257}, },
            {{116, 116, 258}, },
            {{109, 109, 259}, {110, 110, 260}, },
            {{113, 113, 261}, },
            {{109, 109, 262}, },
            {{111, 111, 263}, },
            {{114, 114, 264}, },
            {{112, 112, 265}, },
            {{100, 100, 266}, },
            {{116, 116, 267}, },
            {{113, 113, 268}, },
            {{116, 116, 269}, },
            {{116, 116, 270}, },
            {{108, 108, 271}, },
            {{117, 117, 272}, },
            {{110, 110, 273}, },
            {{119, 119, 274}, },
            {{114, 114, 275}, },
            {{117, 117, 276}, },
            {{111, 111, 277}, },
            {{110, 110, 278}, },
            {{108, 108, 279}, },
            {{116, 116, 280}, },
            {{101, 101, 281}, },
            {{114, 114, 282}, },
            {{98, 98, 283}, },
            {{105, 105, 284}, },
            {{117, 117, 285}, },
            {{110, 110, 286}, },
            {{101, 101, 287}, },
            {{117, 117, 288}, },
            {},
            {{0, 93, -3}, {95, 98, 1}, {99, 99, 289}, {100, 122, 1}, {127, 65535, -3}, },
            {{0, 93, -3}, {95, 114, 1}, {115, 115, 290}, {116, 122, 1}, {127, 65535, -3}, },
            {{0, 65535, -3}, },
            {{0, 93, -3}, {95, 120, 1}, {121, 121, 291}, {122, 122, 1}, {127, 65535, -3}, },
            {{0, 93, -3}, {95, 100, 1}, {101, 101, 292}, {102, 122, 1}, {127, 65535, -3}, },
            {},
            {},
            {},
            {},
            {{62, 62, 293}, },
            {},
            {{0, 57, -3}, {63, 81, 1}, {82, 82, 294}, {83, 91, 1}, {93, 65535, -3}, },
            {{0, 65535, -3}, },
            {{0, 65535, -3}, },
            {{0, 77, -20}, {78, 78, 295}, {79, 65535, -20}, },
            {{116, 116, 296}, },
            {{101, 101, 297}, },
            {{111, 111, 298}, },
            {{101, 101, 299}, {105, 105, 300}, {115, 115, 301}, },
            {{109, 109, 302}, },
            {{108, 108, 303}, },
            {{116, 116, 304}, },
            {{117, 117, 305}, },
            {{105, 105, 306}, },
            {{118, 118, 307}, },
            {{111, 111, 308}, },
            {},
            {{114, 114, 309}, {115, 115, 310}, },
            {{111, 111, 311}, },
            {{116, 116, 312}, },
            {{115, 115, 313}, },
            {{110, 110, 314}, },
            {{109, 109, 315}, },
            {{97, 97, 316}, },
            {},
            {{103, 103, 317}, },
            {{98, 98, 318}, },
            {{100, 100, 319}, },
            {{118, 118, 320}, },
            {{112, 112, 321}, },
            {{116, 116, 322}, },
            {},
            {{115, 115, 323}, },
            {},
            {{49, 49, 324}, },
            {},
            {{105, 105, 325}, {115, 115, 326}, },
            {{121, 121, 327}, },
            {},
            {{110, 110, 328}, },
            {{106, 106, 329}, },
            {{49, 49, 330}, },
            {{111, 111, 331}, },
            {{114, 114, 332}, },
            {{116, 116, 333}, },
            {{114, 114, 334}, {115, 115, 335}, },
            {},
            {{109, 109, 336}, },
            {{108, 108, 337}, },
            {{101, 101, 338}, },
            {{115, 115, 339}, },
            {{106, 106, 340}, },
            {{110, 110, 341}, },
            {{106, 106, 342}, },
            {{108, 108, 343}, },
            {{114, 114, 344}, },
            {{0, 65535, -3}, },
            {{0, 100, -229}, {101, 101, 345}, {102, 65535, -229}, },
            {{0, 93, -3}, {95, 111, 1}, {112, 112, 346}, {113, 122, 1}, {127, 65535, -3}, },
            {{0, 65535, -3}, },
            {},
            {{0, 65535, -3}, },
            {{0, 65535, -3}, },
            {{111, 111, 347}, },
            {{114, 114, 348}, },
            {{110, 110, 349}, },
            {{113, 113, 350}, },
            {{110, 110, 351}, },
            {{117, 117, 352}, },
            {{112, 112, 353}, },
            {{115, 115, 354}, },
            {{101, 101, 355}, },
            {{101, 101, 356}, },
            {{111, 111, 357}, },
            {},
            {{100, 100, 358}, },
            {{101, 101, 359}, },
            {{117, 117, 360}, },
            {{100, 100, 361}, },
            {{121, 121, 362}, },
            {{116, 116, 363}, },
            {},
            {{112, 112, 364}, },
            {{108, 108, 365}, },
            {},
            {{100, 100, 366}, },
            {},
            {},
            {},
            {},
            {{116, 116, 367}, },
            {},
            {{110, 110, 368}, },
            {{117, 117, 369}, },
            {{112, 112, 370}, },
            {},
            {},
            {},
            {{100, 100, 371}, },
            {},
            {},
            {{101, 101, 372}, },
            {{117, 117, 373}, },
            {{105, 105, 374}, },
            {},
            {{108, 108, 375}, },
            {{101, 101, 376}, },
            {},
            {},
            {},
            {},
            {},
            {{0, 65535, -3}, },
            {{0, 100, -229}, {101, 101, 377}, {102, 65535, -229}, },
            {},
            {},
            {},
            {},
            {},
            {{99, 99, 378}, },
            {},
            {{101, 101, 379}, },
            {{114, 114, 380}, },
            {},
            {{110, 110, 381}, },
            {},
            {{115, 115, 382}, },
            {{98, 98, 383}, },
            {},
            {{115, 115, 384}, },
            {{115, 115, 385}, },
            {},
            {{108, 108, 386}, },
            {{97, 97, 387}, },
            {{111, 111, 388}, },
            {},
            {{98, 98, 389}, },
            {{101, 101, 390}, },
            {},
            {{115, 115, 391}, },
            {{98, 98, 392}, },
            {{110, 110, 393}, },
            {},
            {{116, 116, 394}, },
            {{0, 65535, -3}, },
            {{104, 104, 395}, },
            {},
            {},
            {},
            {},
            {},
            {{101, 101, 396}, },
            {},
            {},
            {},
            {},
            {{115, 115, 397}, },
            {},
            {},
            {},
            {{117, 117, 398}, },
            {{101, 101, 399}, },
            {},
            {{116, 116, 400}, },
            {{101, 101, 401}, },
            {{115, 115, 402}, },
            {{113, 113, 403}, },
            {},
            {{116, 116, 404}, },
            {},
            {},
            {{101, 101, 405}, },
            {{113, 113, 406}, },
            {},
        }
    };*/

    private static int[][] accept;
/*  {
        // INITIAL
        {68, 68, 69, 13, 14, 24, 38, 70, 64, 70, 65, 42, 63, 2, 30, 70, 70, 70, 68, 68, 68, 68, 6, 53, 68, 68, 68, 68, 68, 70, 57, 43, 41, 42, 27, 63, 24, 7, 9, 56, 37, 47, 59, 51, 49, 15, 39, 40, 46, 13, 14, 10, 2, 26, 65, 6, 64, 31, 57, 34, 38, 54, 19, 18, 43, 35, 58, 61, 62, 17, 4, 5, 3, 33, 16, 12, 29, 28, 21, 20, 50, 48, 52, 25, 22, 23, 44, 45, 32, 60, 27, 1, -1, -1, -1, -1, 7, 0, 26, -1, 58, 19, -1, 36, 35, 11, 36, 11, 60, -1, 5, -1, 61, 20, 39, -1, -1, 33, 62, 68, 68, 68, 68, 18, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, 68, 68, 68, 68, 54, 68, 10, -1, 21, 34, 8, 55, 46, 50, 47, 51, 3, -1, 66, 59, -1, 17, 22, 40, 48, 49, 37, 9, 56, 68, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, 2, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, 67, 68, 68, 41, 68, 68, 15, 23, 4, 45, 44, 52, 68, 8, 55, 68, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, 63, -1, -1, -1, -1, -1, -1, -1, 62, -1, -1, -1, 61, -1, -1, 54, -1, 57, 9, 58, -1, -1, 60, -1, -1, 56, -1, -1, -1, -1, 59, -1, -1, -1, -1, -1, -1, -1, -1, -1, 31, 68, 68, 16, 32, 29, 28, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, 43, -1, -1, -1, -1, -1, -1, 53, -1, -1, 37, -1, 38, 40, 39, 41, -1, 8, -1, -1, -1, 46, 48, 55, -1, 50, 42, -1, -1, -1, 45, -1, -1, 52, 47, 49, 44, 51, 12, 68, 7, 29, 28, 35, 36, -1, 31, -1, -1, 16, -1, 27, -1, -1, 33, -1, -1, 30, -1, -1, -1, 26, -1, -1, 34, -1, -1, -1, 32, -1, 25, -1, 12, 19, 18, 20, 22, -1, 14, 13, 24, 15, -1, 25, 21, 23, -1, 17, 11, -1, -1, -1, -1, 10, -1, 6, 5, 4, -1, 3, },

    };*/

    public static class State
    {
        public final static State INITIAL = new State(0);

        private int id;

        private State(  int id)
        {
            this.id = id;
        }

        public int id()
        {
            return this.id;
        }
    }

    static 
    {
        try
        {
            DataInputStream s = new DataInputStream(
                new BufferedInputStream(
                Lexer.class.getResourceAsStream("lexer.dat")));

            // read gotoTable
            int length = s.readInt();
            gotoTable = new int[length][][][];
            for(int i = 0; i < gotoTable.length; i++)
            {
                length = s.readInt();
                gotoTable[i] = new int[length][][];
                for(int j = 0; j < gotoTable[i].length; j++)
                {
                    length = s.readInt();
                    gotoTable[i][j] = new int[length][3];
                    for(int k = 0; k < gotoTable[i][j].length; k++)
                    {
                        for(int l = 0; l < 3; l++)
                        {
                            gotoTable[i][j][k][l] = s.readInt();
                        }
                    }
                }
            }

            // read accept
            length = s.readInt();
            accept = new int[length][];
            for(int i = 0; i < accept.length; i++)
            {
                length = s.readInt();
                accept[i] = new int[length];
                for(int j = 0; j < accept[i].length; j++)
                {
                    accept[i][j] = s.readInt();
                }
            }

            s.close();
        }
        catch(Exception e)
        {
            throw new RuntimeException("The file \"lexer.dat\" is either missing or corrupted.");
        }
    }
}
